# THIS IS AN (G)AWK PROGRAM FOR PATCHING ThETA FONTS

BEGIN {
  if (BLEV>0) {# ``badness level'' > 0, i.e., second edition
    # onesuperior
    # yen
    CV["ordmasculine"]="ae"
    CV["ordfeminine"]="AE"
    CV["tilde"]="ecircumflex"
    CV["circumflex"]="Ecircumflex"
    # threesuperior
    # sterling
    CV["onequarter"]="ntilde"
    CV["logicalnot"]="Ntilde"
    CV["c157"]="oe"
    CV["c141"]="OE"
    CV["cent"]="questiondown"
    # macron
    CV["florin"]="Ydieresis"
  #
    CV["c142"]="Zcaron"
    CV["c158"]="zcaron"
  ###
    CV["onesuperior"]="aogonek"
    CV["yen"]="Aogonek"
    CV["ae"]="cacute"
    CV["AE"]="Cacute"
    CV["ecircumflex"]="eogonek"
    CV["Ecircumflex"]="Eogonek"
    CV["threesuperior"]="lslash"
    CV["sterling"]="Lslash"
    CV["ntilde"]="nacute"
    CV["Ntilde"]="Nacute"
  # CV["oacute"]="oacute"
  # CV["Oacute"]="Oacute"
    CV["oe"]="sacute"
    CV["OE"]="Sacute"
    CV["questiondown"]="zdotaccent"
    CV["macron"]="Zdotaccent"
    CV["Ydieresis"]="zacute"
    CV["c143"]="Zacute"
  ###
  }
  CV["zdot"]="zdotaccent"
  CV["Zdot"]="Zdotaccent"
  #
  was_charstrings=0; was_notdef=0; do_patch=0 # let's be explicit
}

/Kuba Tatarkiewicz/ {do_patch=1}
/TeX patch by BOP s.c., Gda\\'nsk/ {do_patch=0}
do_patch {gsub(/Kuba Tatarkiewicz/, "&; TeX patch by BOP s.c., Gda\\'nsk")}

do_patch && A && ($1=="C") && ($2>255) {$2=-1}

do_patch && P && /^[^%]/ {del_comments=1}
do_patch && del_comments {gsub(/[ \t]*%.*$/, "")}

do_patch && P && /\/CharStrings/ {was_charstrings=1}
do_patch && was_charstrings && /\/\.notdef/ {was_notdef=1}
/^[ \t]*end[^a-z]/ && was_charstrings && (!was_notdef) {
  print "/.notdef {\n\t0 333 hsbw\n\tendchar\n\t} ND"; was_notdef=1
}

do_patch && /./ {
  t=$0; h=""
  while (match(t,/[a-zA-Z0-9\.]+/)) {# [a-zA-Z0-9\.] matches reasonable names
    if (substr(t,RSTART,RLENGTH) in CV)
      h=h substr(t,1,RSTART-1) CV[substr(t,RSTART,RLENGTH)]
    else
      h=h substr(t,1,RSTART+RLENGTH-1)
    t=substr(t,RSTART+RLENGTH)
  }
  print h t
}

!do_patch {print}

END {
  if (!do_patch) {
    print "P: FONT NIE ZMIENIONY" > "CON"
    print "E: FONT LEFT INTACT" > "CON"
  }
}

