@echo off
REM  
REM  Naprawiarka do font\'ow THETA (ed. 1) zmontowana w BOP s.c., Gda\'nsk
REM  A patch for ThETA fonts (ed. 1) 
REM  
if "%1"=="" goto BADARG
if exist %1.pfb goto CONT
goto ERR1
:CONT
if exist %1.afm goto CONTA
goto ERR1
:CONTA
if exist %1.pf  goto ERR2
if exist %1.af  goto ERR2
echo Font ThETA %1
:: ----
attrib -R %1.pfb 
ren %1.pfb %1.pf
t1disasm.exe %1.pf _tmp_p_.src
gawk -fthetafix.awk -vP=1 _tmp_p_.src > _tmp_p_.res
t1asm -b _tmp_p_.res %1.pfb
del _tmp_p_.src
del _tmp_p_.res
:: ----
attrib -R %1.afm
ren %1.afm %1.af
gawk -fthetafix.awk -vA=1 %1.af > %1.afm
:: ----
echo OK
goto END

:BADARG
echo P: Program do naprawiania font\'ow z CD THETA (ed. 1)
echo P: U\.zycie: thetfix1 nazwa_fontu (bez rozszerzenia)
echo E: A patch for ThETA fonts (ed. 1) 
echo E: Usage: thetfix1 font_name (without extension)
goto END
:ERR1
echo P: Brak pliku %1.pfb lub %1.afm
echo E: Missing file: %1.pfb or %1.afm
goto END
:ERR2
echo P: Istnieje plik %1.pf lub %1.af
echo E: Either %1.pf or %1.af exists
goto END
:END

